<!DOCTYPE html>
<html>
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Farmwise Image Collecting Rover</title>
    <!--<link href="css-car/entireframework.min.css" rel="stylesheet" type="text/css">-->
    <link href="css-car/custom.css" rel="stylesheet" type="text/css">
    <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/boxicons@latest/css/boxicons.min.css">
    <link rel="stylesheet" href="assets/css/styles.css">
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/css/bootstrap.min.css">
</head>
<body>
        <header class="header" id="header">
                       <nav class="nav container">
                <a href="#" class="nav__logo">FarmWise</a>
                <div class="nav__menu" id="nav-menu">
                    <ul class="nav__list">
                        <li class="nav__item">
                            <a href="index.html" class="nav__link active-link">
                                <i class='bx bx-home-alt nav__icon'></i>
                                <span class="nav__name">Home</span>
                            </a>
                        </li>
                        
                        <li class="nav__item">
                            <a href="controls.html" class="nav__link">
                                <i class='bx bx-user nav__icon'></i>
                                <span class="nav__name">Controls</span>
                            </a>
                        </li>

                        <li class="nav__item">
                             <a href="predictions.html" class="nav__link">
                                <i class='bx bx-book-alt nav__icon'></i>
                                <span class="nav__name">Predictions</span>
                            </a>
                        </li>
                      <li class="nav__item">
                             <a href="rover.html" class="nav__link">
                                <i class='bx bx-book-alt nav__icon'></i>
                                <span class="nav__name">Rover</span>
                            </a>
                        </li>
                        <li class="nav__item">
                            <a href="controls.html" class="nav__link">
                                <i class='bx bx-message-square-detail nav__icon'></i>
                                <span class="nav__name">Control Pump</span>
                            </a>
                        </li>
                    </ul>
                </div>
                <img src="assets/img/perfil.png" alt="" class="nav__img">
            </nav>
        </header>
    <main>
    <section class="container section section__height" id="home">
    <div class="container">
    <div class="parent">
    <div class="speed-settings">Speed Settings</div>
    <div class="wrapper">
    <input type="radio" name="speed-settings" id="option-1" value="slow-speed" %SPEED_SLOW_STATUS%>
    <input type="radio" name="speed-settings" id="option-2" value="normal-speed" %SPEED_NORMAL_STATUS%>
    <input type="radio" name="speed-settings" id="option-3" value="fast-speed" %SPEED_FAST_STATUS%>
    <label for="option-1" class="option option-1">
    <div class="dot"></div>
    <span>Slow</span>
    </label>
    <label for="option-2" class="option option-2">
    <div class="dot"></div>
    <span>Normal</span>
    </label>
    <label for="option-3" class="option option-3">
    <div class="dot"></div>
    <span>Fast</span>
    </label>
    </div>
    <div class="set blue">
    <nav class="d-pad">
    <a class="up control" data-direction="up"></a>
    <a class="right control" data-direction="right"></a>
    <a class="down control" data-direction="down"></a>
    <a class="left control" data-direction="left"></a>
    </nav>      

    <div class="pantilt">
    <button class="tilt-up control" data-direction="tilt-up">T-U</button>
    <button class="pan-right control" data-direction="pan-right">P-R</button>
    <button class="tilt-down control" data-direction="tilt-down">T-D</button>
    <button class="pan-left control" data-direction="pan-left">P-L</button>
    </div>
        <div id="imageContainer">
        <h3>Live Stream</h3>
        <img id="imagePreview" src="" alt="Image Preview">
    </div>
    </div>
    <h3>Rover Image Display</h3>
    <div id="imageCarousel" class="carousel slide" data-ride="carousel">
    <div class="carousel-inner" id="carouselInner"></div>
    <a class="carousel-control-prev" href="#imageCarousel" role="button" data-slide="prev">
    <span class="carousel-control-prev-icon" aria-hidden="true"></span>
    <span class="sr-only">Previous</span>
    </a>
    <a class="carousel-control-next" href="#imageCarousel" role="button" data-slide="next">
    <span class="carousel-control-next-icon" aria-hidden="true"></span>
    <span class="sr-only">Next</span>
    </a>
    </div>
    </div>
    </div>
    </main>
    <script src="https://code.jquery.com/jquery-3.2.1.slim.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.12.9/umd/popper.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.0.0/js/bootstrap.min.js"></script>
    <script src="js-car/custom.js"></script>
        <script>
        document.addEventListener("DOMContentLoaded", function() {
            const carouselInner = document.getElementById('carouselInner');

            // Fetch images dynamically
            fetch('/getImages')
                .then(response => response.json())
                .then(images => {
                    images.forEach((image, index) => {
                        const carouselItem = document.createElement('div');
                        carouselItem.className = `carousel-item ${index === 0 ? 'active' : ''}`;

                        const img = document.createElement('img');
                        img.src = `/images/${image}`;
                        img.className = 'd-block w-100';
                        img.alt = image;

                        carouselItem.appendChild(img);
                        carouselInner.appendChild(carouselItem);
                    });
                })
                .catch(error => console.error('Error fetching images:', error));
        });
        
            //Streaming here
            document.addEventListener("DOMContentLoaded", function () {
                const liveStream = document.getElementById('liveStream');
                
                // Fetch live stream dynamically
                fetch('/live_stream')
                    .then(response => {
                        // Attach the live stream to the <video> tag
                        liveStream.srcObject = response.body;
                        return response;
                    })
                    .catch(error => console.error('Error fetching live stream:', error));
            });

    </script>
       <script>
        const imageContainer = document.getElementById('imageContainer');
        const imagePreview = document.getElementById('imagePreview');
        const socket = new WebSocket('ws://localhost:4000'); // Adjust the WebSocket URL accordingly

        socket.binaryType = 'arraybuffer'; // Set binary data type

        socket.addEventListener('open', (event) => {
            console.log('WebSocket connection opened.');
        });

        socket.addEventListener('message', (event) => {
            if (event.data instanceof ArrayBuffer) {
                // Convert ArrayBuffer to Blob
                const blob = new Blob([event.data], { type: 'image/jpeg' }); // Adjust the media type based on your image format
                console.log('Received binary image data.');

                // Set the image source and display the image
                const imageUrl = URL.createObjectURL(blob);
                imagePreview.src = imageUrl;

                // Display the image container
                imageContainer.style.display = 'block';
            }
        });

        socket.addEventListener('close', (event) => {
            console.log('WebSocket connection closed.');
        });

        socket.addEventListener('error', (event) => {
            console.error('WebSocket error:', event);
        });
    </script>

    </div>
    </div>
</body>

</html>